import numpy as np

STANDARD_CHEMICAL_MEASURES = {
    "bonds": (
        np.array(
            [
                [
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                ],
                [
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    1.328,
                ],
                [
                    1.461,
                    1.526,
                    1.233,
                    1.524,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    1.336,
                ],
                [
                    1.461,
                    1.526,
                    1.234,
                    1.531,
                    1.52,
                    1.521,
                    1.46,
                    1.33,
                    1.328,
                    1.327,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    1.341,
                ],
                [
                    1.461,
                    1.526,
                    1.232,
                    1.53,
                    1.515,
                    1.232,
                    1.327,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    1.348,
                ],
                [
                    1.462,
                    1.526,
                    1.233,
                    1.532,
                    1.519,
                    1.25,
                    1.251,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    1.343,
                ],
                [
                    1.461,
                    1.525,
                    1.233,
                    1.528,
                    1.807,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    1.335,
                ],
                [
                    1.461,
                    1.526,
                    1.233,
                    1.531,
                    1.521,
                    1.517,
                    1.233,
                    1.328,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    1.342,
                ],
                [
                    1.462,
                    1.527,
                    1.233,
                    1.532,
                    1.521,
                    1.522,
                    1.252,
                    1.252,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    1.334,
                ],
                [
                    1.455,
                    1.516,
                    1.234,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    1.339,
                ],
                [
                    1.461,
                    1.524,
                    1.233,
                    1.531,
                    1.495,
                    1.378,
                    1.323,
                    1.323,
                    1.373,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    1.33,
                ],
                [
                    1.461,
                    1.526,
                    1.234,
                    1.544,
                    1.533,
                    1.517,
                    1.528,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    1.334,
                ],
                [
                    1.461,
                    1.524,
                    1.233,
                    1.53,
                    1.529,
                    1.522,
                    1.523,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    1.337,
                ],
                [
                    1.462,
                    1.525,
                    1.233,
                    1.531,
                    1.522,
                    1.521,
                    1.522,
                    1.492,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    1.331,
                ],
                [
                    1.462,
                    1.525,
                    1.234,
                    1.531,
                    1.519,
                    1.804,
                    1.788,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    1.331,
                ],
                [
                    1.461,
                    1.524,
                    1.233,
                    1.533,
                    1.504,
                    1.388,
                    1.391,
                    1.383,
                    1.383,
                    1.39,
                    1.388,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    1.331,
                ],
                [
                    1.466,
                    1.525,
                    1.233,
                    1.533,
                    1.494,
                    1.505,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    1.34,
                ],
                [
                    1.461,
                    1.525,
                    1.234,
                    1.529,
                    1.417,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    1.365,
                ],
                [
                    1.461,
                    1.525,
                    1.234,
                    1.539,
                    1.433,
                    1.523,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    1.343,
                ],
                [
                    1.46,
                    1.523,
                    1.234,
                    1.533,
                    1.499,
                    1.368,
                    1.375,
                    1.37,
                    1.396,
                    1.371,
                    1.403,
                    1.388,
                    1.4,
                    1.413,
                    1.434,
                    1.33,
                ],
                [
                    1.46,
                    1.524,
                    1.233,
                    1.532,
                    1.51,
                    1.391,
                    1.388,
                    1.382,
                    1.377,
                    1.381,
                    1.387,
                    1.39,
                    0.0,
                    0.0,
                    0.0,
                    1.331,
                ],
                [
                    1.461,
                    1.526,
                    1.234,
                    1.544,
                    1.525,
                    1.525,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    1.349,
                ],
            ]
        ),
        np.array(
            [
                [
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                ],
                [
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    8.575e-05,
                ],
                [
                    1.342e-04,
                    1.149e-04,
                    1.262e-04,
                    2.133e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    7.457e-02,
                ],
                [
                    1.429e-04,
                    1.187e-04,
                    1.439e-04,
                    1.004e-04,
                    2.878e-04,
                    2.849e-04,
                    1.141e-04,
                    5.967e-05,
                    9.918e-05,
                    9.022e-05,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    5.135e-02,
                ],
                [
                    1.364e-04,
                    1.150e-04,
                    1.419e-04,
                    1.183e-04,
                    1.901e-04,
                    1.801e-04,
                    1.645e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.617e-01,
                ],
                [
                    1.581e-04,
                    9.924e-05,
                    1.200e-04,
                    1.063e-04,
                    1.967e-04,
                    1.225e-04,
                    1.309e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.142e-01,
                ],
                [
                    2.036e-04,
                    1.594e-04,
                    2.044e-04,
                    1.842e-04,
                    4.443e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    6.282e-03,
                ],
                [
                    1.575e-04,
                    1.116e-04,
                    1.395e-04,
                    9.976e-05,
                    2.994e-04,
                    2.054e-04,
                    1.339e-04,
                    1.678e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    5.247e-02,
                ],
                [
                    1.313e-04,
                    1.283e-04,
                    1.211e-04,
                    1.116e-04,
                    3.173e-04,
                    1.875e-04,
                    1.461e-04,
                    5.025e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.276e-02,
                ],
                [
                    1.489e-04,
                    9.640e-05,
                    1.310e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    6.531e-02,
                ],
                [
                    1.481e-04,
                    1.239e-04,
                    1.268e-04,
                    1.293e-04,
                    7.899e-05,
                    8.632e-05,
                    5.651e-05,
                    1.039e-04,
                    6.078e-05,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    8.551e-05,
                ],
                [
                    1.321e-04,
                    1.115e-04,
                    1.183e-04,
                    1.640e-04,
                    1.161e-04,
                    4.876e-04,
                    2.392e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.478e-02,
                ],
                [
                    1.320e-04,
                    1.088e-04,
                    1.383e-04,
                    1.028e-04,
                    1.379e-04,
                    2.244e-04,
                    2.320e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    4.624e-02,
                ],
                [
                    1.301e-04,
                    1.275e-04,
                    1.298e-04,
                    1.061e-04,
                    2.788e-04,
                    2.890e-04,
                    2.246e-04,
                    2.233e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    8.231e-05,
                ],
                [
                    1.367e-04,
                    9.864e-05,
                    1.541e-04,
                    1.055e-04,
                    3.838e-04,
                    3.504e-04,
                    4.578e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    7.424e-05,
                ],
                [
                    1.415e-04,
                    1.168e-04,
                    1.322e-04,
                    1.372e-04,
                    1.468e-04,
                    1.249e-04,
                    1.858e-04,
                    2.090e-04,
                    1.923e-04,
                    1.630e-04,
                    1.301e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    8.415e-05,
                ],
                [
                    1.103e-04,
                    1.173e-04,
                    1.467e-04,
                    9.530e-05,
                    5.075e-04,
                    2.841e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.275e-01,
                ],
                [
                    1.449e-04,
                    1.245e-04,
                    1.322e-04,
                    1.759e-04,
                    1.563e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    7.013e-01,
                ],
                [
                    1.275e-04,
                    1.121e-04,
                    1.152e-04,
                    1.842e-04,
                    8.256e-05,
                    3.311e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.627e-01,
                ],
                [
                    1.697e-04,
                    1.226e-04,
                    1.401e-04,
                    1.411e-04,
                    3.812e-04,
                    1.746e-04,
                    1.237e-04,
                    5.090e-05,
                    1.145e-04,
                    1.019e-04,
                    1.631e-04,
                    2.755e-04,
                    5.943e-05,
                    1.572e-04,
                    1.116e-04,
                    8.033e-05,
                ],
                [
                    1.364e-04,
                    1.118e-04,
                    1.313e-04,
                    1.367e-04,
                    1.650e-04,
                    1.293e-04,
                    1.779e-04,
                    1.580e-04,
                    1.389e-04,
                    1.370e-04,
                    2.129e-04,
                    1.276e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    8.031e-05,
                ],
                [
                    1.438e-04,
                    1.121e-04,
                    1.334e-04,
                    1.635e-04,
                    2.466e-04,
                    2.548e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.600e-01,
                ],
            ]
        ),
    ),
    "angles": (
        np.array(
            [
                [
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                ],
                [
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.035,
                    2.127,
                ],
                [
                    2.102,
                    1.937,
                    1.927,
                    1.926,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.037,
                    2.12,
                ],
                [
                    2.101,
                    1.935,
                    1.931,
                    1.989,
                    1.923,
                    1.951,
                    1.95,
                    2.178,
                    2.105,
                    2.091,
                    2.088,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.037,
                    2.12,
                ],
                [
                    2.099,
                    1.942,
                    1.93,
                    1.967,
                    1.93,
                    2.11,
                    2.032,
                    2.141,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.04,
                    2.12,
                ],
                [
                    2.1,
                    1.937,
                    1.929,
                    1.974,
                    1.925,
                    2.078,
                    2.059,
                    2.145,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.039,
                    2.121,
                ],
                [
                    2.1,
                    1.927,
                    1.931,
                    1.985,
                    1.925,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.036,
                    2.122,
                ],
                [
                    2.1,
                    1.938,
                    1.93,
                    1.986,
                    1.923,
                    1.969,
                    2.111,
                    2.032,
                    2.139,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.038,
                    2.119,
                ],
                [
                    2.1,
                    1.94,
                    1.93,
                    1.988,
                    1.925,
                    1.981,
                    2.076,
                    2.061,
                    2.145,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.04,
                    2.12,
                ],
                [
                    2.101,
                    1.975,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.037,
                    2.123,
                ],
                [
                    2.1,
                    1.937,
                    1.93,
                    1.983,
                    1.925,
                    2.14,
                    1.906,
                    1.893,
                    1.899,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.037,
                    2.12,
                ],
                [
                    2.103,
                    1.913,
                    1.944,
                    1.93,
                    1.932,
                    1.932,
                    1.989,
                    1.938,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.037,
                    2.12,
                ],
                [
                    2.1,
                    1.934,
                    1.928,
                    2.026,
                    1.922,
                    1.928,
                    1.933,
                    1.932,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.038,
                    2.119,
                ],
                [
                    2.101,
                    1.937,
                    1.93,
                    1.989,
                    1.924,
                    1.95,
                    1.948,
                    1.949,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.038,
                    2.119,
                ],
                [
                    2.101,
                    1.933,
                    1.93,
                    1.986,
                    1.923,
                    1.966,
                    1.759,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.038,
                    2.12,
                ],
                [
                    2.102,
                    1.933,
                    1.93,
                    1.987,
                    1.924,
                    2.107,
                    2.103,
                    2.107,
                    2.108,
                    2.072,
                    2.092,
                    2.093,
                    2.093,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.035,
                    2.12,
                ],
                [
                    2.098,
                    1.967,
                    1.802,
                    1.822,
                    1.934,
                    1.84,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.036,
                    2.122,
                ],
                [
                    2.101,
                    1.94,
                    1.93,
                    1.935,
                    1.919,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.037,
                    2.12,
                ],
                [
                    2.102,
                    1.929,
                    1.94,
                    1.907,
                    1.941,
                    1.917,
                    1.909,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.035,
                    2.121,
                ],
                [
                    2.102,
                    1.936,
                    1.93,
                    1.988,
                    1.92,
                    2.218,
                    2.21,
                    1.922,
                    2.337,
                    1.871,
                    1.854,
                    1.902,
                    2.272,
                    1.875,
                    2.05,
                    2.075,
                    2.135,
                    2.121,
                    2.113,
                    2.071,
                    2.035,
                    2.123,
                ],
                [
                    2.102,
                    1.935,
                    1.93,
                    1.987,
                    1.924,
                    2.111,
                    2.109,
                    2.114,
                    2.115,
                    2.062,
                    2.087,
                    2.092,
                    2.1,
                    2.087,
                    2.091,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.035,
                    2.12,
                ],
                [
                    2.103,
                    1.914,
                    1.946,
                    1.935,
                    1.93,
                    1.93,
                    1.932,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    2.035,
                    2.121,
                ],
            ]
        ),
        np.array(
            [
                [
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                ],
                [
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.929e-03,
                    6.318e-04,
                ],
                [
                    2.756e-04,
                    1.256e-03,
                    2.429e-04,
                    3.148e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    8.026e-04,
                    1.188e-03,
                ],
                [
                    3.226e-04,
                    1.385e-03,
                    4.770e-04,
                    1.040e-03,
                    8.860e-04,
                    1.259e-03,
                    1.592e-03,
                    4.415e-04,
                    3.313e-04,
                    2.831e-04,
                    1.814e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    7.337e-04,
                    1.849e-03,
                ],
                [
                    3.454e-04,
                    2.087e-03,
                    5.205e-04,
                    3.372e-04,
                    9.343e-04,
                    3.605e-04,
                    3.239e-04,
                    1.459e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.407e-03,
                    1.880e-03,
                ],
                [
                    3.230e-04,
                    1.989e-03,
                    5.378e-04,
                    3.920e-04,
                    9.475e-04,
                    5.476e-04,
                    5.566e-04,
                    4.817e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    5.746e-04,
                    8.944e-04,
                ],
                [
                    4.544e-04,
                    1.739e-03,
                    7.260e-04,
                    1.434e-03,
                    1.068e-03,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.069e-03,
                    1.255e-03,
                ],
                [
                    3.015e-04,
                    1.328e-03,
                    4.433e-04,
                    1.105e-03,
                    8.301e-04,
                    8.345e-04,
                    2.318e-04,
                    2.455e-04,
                    1.642e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    2.124e-03,
                    1.320e-03,
                ],
                [
                    3.492e-04,
                    1.311e-03,
                    4.714e-04,
                    1.060e-03,
                    7.990e-04,
                    9.891e-04,
                    6.188e-04,
                    6.415e-04,
                    6.289e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    4.640e-04,
                    7.628e-04,
                ],
                [
                    4.313e-04,
                    2.037e-03,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    9.816e-04,
                    1.035e-03,
                ],
                [
                    4.051e-04,
                    1.823e-03,
                    4.975e-04,
                    3.776e-04,
                    1.030e-03,
                    1.593e-04,
                    1.309e-04,
                    1.055e-04,
                    7.867e-05,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.675e-03,
                    3.306e-03,
                ],
                [
                    2.633e-04,
                    1.517e-03,
                    5.060e-04,
                    5.410e-04,
                    3.143e-04,
                    8.751e-04,
                    5.135e-04,
                    6.856e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    4.081e-04,
                    8.280e-04,
                ],
                [
                    2.984e-04,
                    1.519e-03,
                    3.639e-04,
                    1.640e-03,
                    6.251e-04,
                    8.313e-04,
                    8.738e-04,
                    4.326e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    6.870e-04,
                    8.626e-04,
                ],
                [
                    3.184e-04,
                    1.369e-03,
                    3.811e-04,
                    9.052e-04,
                    7.043e-04,
                    1.035e-03,
                    8.776e-04,
                    1.606e-03,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    4.325e-04,
                    1.920e-03,
                ],
                [
                    2.782e-04,
                    1.411e-03,
                    5.044e-04,
                    9.241e-04,
                    6.421e-04,
                    1.889e-03,
                    1.245e-03,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    4.092e-04,
                    7.390e-04,
                ],
                [
                    3.073e-04,
                    1.738e-03,
                    5.659e-04,
                    4.586e-04,
                    1.099e-03,
                    1.867e-04,
                    1.705e-04,
                    9.465e-05,
                    1.059e-04,
                    9.671e-05,
                    1.192e-04,
                    1.466e-04,
                    1.110e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.093e-03,
                    1.053e-03,
                ],
                [
                    4.429e-04,
                    1.393e-03,
                    1.558e-04,
                    5.166e-04,
                    5.420e-04,
                    1.175e-03,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.536e-03,
                    1.303e-03,
                ],
                [
                    3.503e-04,
                    1.466e-03,
                    4.039e-04,
                    6.310e-04,
                    7.265e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.166e-03,
                    2.204e-03,
                ],
                [
                    2.969e-04,
                    1.740e-03,
                    5.401e-04,
                    3.787e-04,
                    3.581e-04,
                    1.008e-03,
                    6.107e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.369e-03,
                    1.109e-03,
                ],
                [
                    2.954e-04,
                    1.857e-03,
                    4.959e-04,
                    1.732e-03,
                    9.671e-04,
                    1.622e-04,
                    2.101e-04,
                    5.648e-05,
                    4.380e-05,
                    3.706e-05,
                    5.189e-05,
                    9.155e-05,
                    5.698e-05,
                    3.993e-05,
                    6.351e-05,
                    3.269e-05,
                    3.626e-05,
                    9.112e-05,
                    1.005e-04,
                    6.323e-05,
                    4.259e-04,
                    1.001e-03,
                ],
                [
                    2.912e-04,
                    1.697e-03,
                    5.337e-04,
                    1.500e-03,
                    9.653e-04,
                    1.617e-04,
                    1.529e-04,
                    9.584e-05,
                    1.179e-04,
                    9.908e-05,
                    1.265e-04,
                    6.124e-04,
                    1.794e-04,
                    1.134e-04,
                    6.060e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    4.666e-04,
                    8.464e-04,
                ],
                [
                    2.631e-04,
                    1.471e-03,
                    4.684e-04,
                    3.468e-04,
                    3.929e-04,
                    7.092e-04,
                    3.977e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    6.377e-04,
                    1.505e-03,
                ],
            ]
        ),
    ),
    "dihedrals": (
        np.array(
            [
                [
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                ],
                [
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                ],
                [
                    1.828,
                    1.523,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.528,
                    1.519,
                    1.426,
                ],
                [
                    1.817,
                    1.792,
                    2.612,
                    2.129,
                    1.456,
                    2.022,
                    2.133,
                    0.443,
                    2.709,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.548,
                    1.49,
                    1.574,
                ],
                [
                    1.909,
                    1.703,
                    0.876,
                    2.263,
                    2.074,
                    1.204,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.54,
                    1.566,
                    1.47,
                ],
                [
                    1.925,
                    1.748,
                    0.649,
                    2.496,
                    2.065,
                    1.292,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.553,
                    1.586,
                    1.332,
                ],
                [
                    1.465,
                    1.761,
                    1.915,
                    1.426,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.669,
                    1.626,
                    1.646,
                ],
                [
                    1.854,
                    1.724,
                    2.31,
                    2.219,
                    1.447,
                    0.989,
                    2.152,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.537,
                    1.493,
                    1.527,
                ],
                [
                    1.973,
                    1.753,
                    2.342,
                    2.155,
                    1.497,
                    0.888,
                    2.256,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.467,
                    1.487,
                    1.335,
                ],
                [
                    1.742,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                ],
                [
                    1.738,
                    1.76,
                    1.592,
                    2.091,
                    1.357,
                    3.119,
                    0.015,
                    0.014,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.577,
                    1.557,
                    1.554,
                ],
                [
                    1.524,
                    1.266,
                    2.576,
                    2.555,
                    2.576,
                    1.211,
                    1.426,
                    1.231,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.639,
                    1.561,
                    1.822,
                ],
                [
                    1.816,
                    1.768,
                    2.324,
                    1.749,
                    2.295,
                    1.447,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.554,
                    1.541,
                    1.562,
                ],
                [
                    1.85,
                    1.82,
                    2.588,
                    2.127,
                    1.46,
                    2.563,
                    2.315,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.532,
                    1.459,
                    1.578,
                ],
                [
                    1.727,
                    1.684,
                    2.349,
                    2.241,
                    1.456,
                    1.531,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.584,
                    1.521,
                    1.585,
                ],
                [
                    1.572,
                    1.762,
                    1.307,
                    1.835,
                    2.092,
                    1.42,
                    3.119,
                    3.119,
                    0.019,
                    0.018,
                    0.021,
                    0.017,
                    0.022,
                    0.017,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.628,
                    1.557,
                    1.744,
                ],
                [
                    1.394,
                    0.434,
                    0.584,
                    2.091,
                    1.449,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.655,
                    1.545,
                    1.696,
                ],
                [
                    1.592,
                    1.578,
                    1.598,
                    1.49,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.628,
                    1.616,
                    1.573,
                ],
                [
                    1.474,
                    1.226,
                    1.946,
                    1.956,
                    1.948,
                    1.501,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.676,
                    1.603,
                    1.748,
                ],
                [
                    1.626,
                    1.69,
                    1.492,
                    1.652,
                    2.106,
                    1.444,
                    3.115,
                    0.036,
                    3.116,
                    0.017,
                    3.127,
                    0.016,
                    3.129,
                    3.126,
                    0.016,
                    3.128,
                    0.016,
                    0.017,
                    3.127,
                    3.129,
                    0.019,
                    0.019,
                    0.02,
                    0.019,
                    0.019,
                    0.019,
                    0.59,
                    1.531,
                    1.754,
                ],
                [
                    1.569,
                    1.773,
                    1.311,
                    1.826,
                    2.054,
                    1.438,
                    3.117,
                    3.117,
                    0.018,
                    0.019,
                    0.021,
                    3.128,
                    0.018,
                    0.021,
                    0.018,
                    3.128,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.629,
                    1.543,
                    1.774,
                ],
                [
                    1.455,
                    2.503,
                    1.245,
                    1.325,
                    2.504,
                    1.43,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.0,
                    0.655,
                    1.544,
                    1.902,
                ],
            ]
        ),
        np.array(
            [
                [
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                ],
                [
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                ],
                [
                    8.714e-01,
                    1.291e-01,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.236e-01,
                    1.348e-01,
                    1.041e00,
                ],
                [
                    8.605e-01,
                    7.864e-01,
                    5.066e-01,
                    8.939e-01,
                    1.626e-01,
                    8.832e-01,
                    4.589e-01,
                    1.111e00,
                    1.100e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.296e-01,
                    1.334e-01,
                    1.091e00,
                ],
                [
                    9.397e-01,
                    6.905e-01,
                    4.527e-01,
                    4.586e-01,
                    8.158e-01,
                    3.544e-01,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.324e-01,
                    1.893e-01,
                    1.161e00,
                ],
                [
                    8.739e-01,
                    7.188e-01,
                    4.174e-01,
                    4.232e-01,
                    8.062e-01,
                    2.816e-01,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.295e-01,
                    2.414e-01,
                    9.753e-01,
                ],
                [
                    9.040e-01,
                    7.860e-01,
                    9.303e-01,
                    1.879e-01,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.309e-01,
                    1.502e-01,
                    1.145e00,
                ],
                [
                    8.695e-01,
                    7.456e-01,
                    7.735e-01,
                    8.475e-01,
                    1.693e-01,
                    5.282e-01,
                    5.296e-01,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.257e-01,
                    1.401e-01,
                    1.116e00,
                ],
                [
                    7.915e-01,
                    7.697e-01,
                    7.250e-01,
                    8.780e-01,
                    1.210e-01,
                    7.604e-01,
                    7.642e-01,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.127e-01,
                    1.341e-01,
                    9.946e-01,
                ],
                [
                    1.442e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                ],
                [
                    9.467e-01,
                    8.003e-01,
                    3.686e-01,
                    8.932e-01,
                    2.441e-01,
                    5.200e-04,
                    3.405e-04,
                    3.280e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.379e-01,
                    1.695e-01,
                    1.111e00,
                ],
                [
                    6.715e-01,
                    3.132e-01,
                    6.565e-01,
                    5.794e-01,
                    6.492e-01,
                    5.212e-01,
                    1.131e-01,
                    1.315e-01,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.138e-01,
                    9.218e-02,
                    1.167e00,
                ],
                [
                    7.771e-01,
                    7.991e-01,
                    8.181e-01,
                    8.155e-01,
                    8.446e-01,
                    1.248e-01,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.218e-01,
                    1.026e-01,
                    1.154e00,
                ],
                [
                    8.592e-01,
                    8.084e-01,
                    5.662e-01,
                    8.937e-01,
                    1.551e-01,
                    5.695e-01,
                    7.935e-01,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.234e-01,
                    1.378e-01,
                    1.075e00,
                ],
                [
                    9.060e-01,
                    7.184e-01,
                    8.006e-01,
                    8.557e-01,
                    1.535e-01,
                    4.940e-01,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.279e-01,
                    1.104e-01,
                    1.146e00,
                ],
                [
                    8.860e-01,
                    7.754e-01,
                    1.379e-01,
                    1.456e-01,
                    9.227e-01,
                    1.910e-01,
                    4.778e-04,
                    4.597e-04,
                    4.768e-04,
                    4.322e-04,
                    4.928e-04,
                    4.632e-04,
                    4.992e-04,
                    4.229e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.262e-01,
                    9.763e-02,
                    1.140e00,
                ],
                [
                    1.100e00,
                    1.685e-02,
                    1.716e-02,
                    2.074e-01,
                    1.048e-01,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.609e-01,
                    2.444e-01,
                    1.005e00,
                ],
                [
                    1.155e00,
                    6.559e-01,
                    8.482e-01,
                    1.618e-01,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.568e-01,
                    2.801e-01,
                    9.618e-01,
                ],
                [
                    1.073e00,
                    3.049e-01,
                    1.000e00,
                    9.662e-01,
                    1.024e00,
                    1.427e-01,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.445e-01,
                    2.031e-01,
                    1.061e00,
                ],
                [
                    9.531e-01,
                    7.170e-01,
                    2.550e-01,
                    2.669e-01,
                    8.661e-01,
                    1.526e-01,
                    6.734e-04,
                    1.237e-03,
                    6.569e-04,
                    3.905e-04,
                    2.603e-04,
                    2.903e-04,
                    1.765e-04,
                    3.132e-04,
                    2.576e-04,
                    2.747e-04,
                    3.641e-04,
                    3.087e-04,
                    3.101e-04,
                    2.171e-04,
                    4.787e-04,
                    5.073e-04,
                    5.071e-04,
                    5.472e-04,
                    4.596e-04,
                    5.233e-04,
                    1.170e-01,
                    1.185e-01,
                    1.104e00,
                ],
                [
                    9.267e-01,
                    7.971e-01,
                    1.325e-01,
                    1.409e-01,
                    9.406e-01,
                    1.685e-01,
                    6.228e-04,
                    5.549e-04,
                    4.249e-04,
                    4.473e-04,
                    4.697e-04,
                    2.104e-04,
                    4.479e-04,
                    4.573e-04,
                    4.664e-04,
                    2.388e-04,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.181e-01,
                    1.086e-01,
                    1.125e00,
                ],
                [
                    7.024e-01,
                    7.522e-01,
                    3.100e-01,
                    6.442e-01,
                    7.444e-01,
                    1.130e-01,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    0.000e00,
                    1.147e-01,
                    9.496e-02,
                    1.118e00,
                ],
            ],
        ),
    ),
}
